Index: palm/trunk/SOURCE/time_integration.f90
===================================================================
--- palm/trunk/SOURCE/time_integration.f90	(revision 1686)
+++ palm/trunk/SOURCE/time_integration.f90	(revision 1691)
@@ -14,10 +14,11 @@
 ! PALM. If not, see <http://www.gnu.org/licenses/>.
 !
-! Copyright 1997-2014 Leibniz Universitaet Hannover
+! Copyright 1997-2015 Leibniz Universitaet Hannover
 !--------------------------------------------------------------------------------!
 !
 ! Current revisions:
 ! ------------------
-! 
+! Added option for spin-ups without land surface and radiation models. Moved calls
+! for radiation and lan surface schemes.
 ! 
 ! Former revisions:
@@ -170,11 +171,11 @@
                averaging_interval_sp, bc_lr_cyc, bc_ns_cyc, bc_pt_t_val,       &
                bc_q_t_val, call_psolver_at_all_substeps, cloud_droplets,       &
-               cloud_physics, constant_heatflux, create_disturbances, dopr_n,  &
-               constant_diffusion, coupling_mode, coupling_start_time,         &
-               current_timestep_number, disturbance_created,                   &
-               disturbance_energy_limit, dist_range, do_sum, dt_3d,            &
-               dt_averaging_input, dt_averaging_input_pr, dt_coupling,         &
-               dt_data_output_av, dt_disturb, dt_do2d_xy, dt_do2d_xz,          &
-               dt_do2d_yz, dt_do3d, dt_domask,dt_dopts, dt_dopr,               &
+               cloud_physics, constant_flux_layer, constant_heatflux,          &
+               create_disturbances, dopr_n, constant_diffusion, coupling_mode, &
+               coupling_start_time, current_timestep_number,                   &
+               disturbance_created, disturbance_energy_limit, dist_range,      &
+               do_sum, dt_3d, dt_averaging_input, dt_averaging_input_pr,       &
+               dt_coupling, dt_data_output_av, dt_disturb, dt_do2d_xy,         &
+               dt_do2d_xz, dt_do2d_yz, dt_do3d, dt_domask,dt_dopts, dt_dopr,   &
                dt_dopr_listing, dt_dosp, dt_dots, dt_dvrp, dt_run_control,     &
                end_time, first_call_lpm, galilei_transformation, humidity,     &
@@ -183,5 +184,5 @@
                loop_optimization, lsf_surf, lsf_vert, masks, mid,              &
                netcdf_data_format, neutral, nr_timesteps_this_run, nudging,    &
-               ocean, on_device, passive_scalar, prandtl_layer, precipitation, &
+               ocean, on_device, passive_scalar, precipitation,                &
                prho_reference, pt_reference, pt_slope_offset, random_heatflux, &
                run_coupled, simulated_time, simulated_time_chr,                &
@@ -213,5 +214,6 @@
 
     USE land_surface_model_mod,                                                &
-        ONLY:  land_surface, lsm_energy_balance, lsm_soil_model
+        ONLY:  land_surface, lsm_energy_balance, lsm_soil_model,               &
+               skip_time_do_lsm
 
     USE ls_forcing_mod,                                                        &
@@ -238,9 +240,13 @@
 
     USE radiation_model_mod,                                                   &
-        ONLY: dt_radiation, radiation, radiation_clearsky,                     &
-              radiation_rrtmg, radiation_scheme, time_radiation
+        ONLY: dt_radiation, force_radiation_call, radiation,                   &
+              radiation_clearsky, radiation_rrtmg, radiation_scheme,           &
+              skip_time_do_radiation, time_radiation
 
     USE statistics,                                                            &
         ONLY:  flow_statistics_called, hom, pr_palm, sums_ls_l
+
+    USE surface_layer_fluxes_mod,                                              &
+        ONLY:  surface_layer_fluxes
 
     USE user_actions_mod,                                                      &
@@ -374,23 +380,4 @@
           ENDIF
 
-          IF ( radiation .AND. intermediate_timestep_count                     &
-               == intermediate_timestep_count_max  )  THEN
-
-               time_radiation = time_radiation + dt_3d
-
-             IF ( time_radiation >= dt_radiation )  THEN
-
-                CALL cpu_log( log_point(50), 'radiation', 'start' )
-
-                time_radiation = time_radiation - dt_radiation
-                IF ( radiation_scheme == 'clear-sky' )  THEN
-                   CALL radiation_clearsky
-                ELSEIF ( radiation_scheme == 'rrtmg' )  THEN
-                   CALL radiation_rrtmg
-                ENDIF
-
-                CALL cpu_log( log_point(50), 'radiation', 'stop' )
-             ENDIF
-          ENDIF
 !
 !--       Solve the prognostic equations. A fast cache optimized version with
@@ -631,19 +618,4 @@
 !--       velocities at the outflow in case of a non-cyclic lateral wall)
           CALL boundary_conds
-
-!
-!--       When using the land surface model: 
-!--       1) solve energy balance equation to calculate new skin temperature
-!--       2) run soil model 
-          IF ( land_surface )  THEN
-
-             CALL cpu_log( log_point(54), 'land_surface', 'start' )
-
-             CALL lsm_energy_balance
-             CALL lsm_soil_model
-
-             CALL cpu_log( log_point(54), 'land_surface', 'stop' )
-
-          ENDIF
 
 !
@@ -731,11 +703,21 @@
 
 !
-!--          First the vertical fluxes in the Prandtl layer are being computed
-             IF ( prandtl_layer )  THEN
-                CALL cpu_log( log_point(19), 'prandtl_fluxes', 'start' )
-                CALL prandtl_fluxes
-                CALL cpu_log( log_point(19), 'prandtl_fluxes', 'stop' )
-             ENDIF
-
+!--          First the vertical fluxes in the surface (constant flux) layer are computed
+             IF ( constant_flux_layer )  THEN
+                CALL cpu_log( log_point(19), 'surface_layer_fluxes', 'start' )
+                CALL surface_layer_fluxes
+                CALL cpu_log( log_point(19), 'surface_layer_fluxes', 'stop' )
+             ENDIF
+
+!
+!--          If required, solve the energy balance for the surface and run soil 
+!--          model
+             IF ( land_surface .AND. simulated_time > skip_time_do_lsm)  THEN
+
+                CALL cpu_log( log_point(54), 'land_surface', 'start' )
+                CALL lsm_energy_balance
+                CALL lsm_soil_model
+                CALL cpu_log( log_point(54), 'land_surface', 'stop' )
+             ENDIF
 !
 !--          Compute the diffusion coefficients
@@ -752,4 +734,34 @@
              CALL cpu_log( log_point(17), 'diffusivities', 'stop' )
 
+          ENDIF
+
+!
+!--       If required, calculate radiative fluxes and heating rates
+          IF ( radiation .AND. intermediate_timestep_count                     &
+               == intermediate_timestep_count_max .AND. simulated_time >    &
+               skip_time_do_radiation )  THEN
+
+               time_radiation = time_radiation + dt_3d
+
+             IF ( time_radiation >= dt_radiation .OR. force_radiation_call )   &
+             THEN
+
+                CALL cpu_log( log_point(50), 'radiation', 'start' )
+
+                IF ( .NOT. force_radiation_call )  THEN
+                   time_radiation = time_radiation - dt_radiation
+                ELSE
+                   WRITE(9,*) "Unscheduled radiation call at ", simulated_time
+                   CALL LOCAL_FLUSH ( 9 )
+                ENDIF
+
+                IF ( radiation_scheme == 'clear-sky' )  THEN
+                   CALL radiation_clearsky
+                ELSEIF ( radiation_scheme == 'rrtmg' )  THEN
+                   CALL radiation_rrtmg
+                ENDIF
+
+                CALL cpu_log( log_point(50), 'radiation', 'stop' )
+             ENDIF
           ENDIF
 
Index: palm/trunk/SOURCE/wall_fluxes.f90
===================================================================
--- palm/trunk/SOURCE/wall_fluxes.f90	(revision 1686)
+++ palm/trunk/SOURCE/wall_fluxes.f90	(revision 1691)
@@ -14,10 +14,10 @@
 ! PALM. If not, see <http://www.gnu.org/licenses/>.
 !
-! Copyright 1997-2014 Leibniz Universitaet Hannover
+! Copyright 1997-2015 Leibniz Universitaet Hannover
 !--------------------------------------------------------------------------------!
 !
 ! Current revisions:
 ! -----------------
-! 
+! Renamed rif_min and rif_max with zeta_min and zeta_max, respectively.
 ! 
 ! Former revisions:
@@ -69,4 +69,6 @@
 !> it gives slightly different results from the ij-version for some unknown
 !> reason.
+!>
+!> @todo Rename rif to zeta throughout the routine
 !------------------------------------------------------------------------------!
  MODULE wall_fluxes_mod
@@ -107,5 +109,5 @@
        
        USE control_parameters,                                                 &
-           ONLY:  g, kappa, rif_max, rif_min
+           ONLY:  g, kappa, zeta_max, zeta_min
        
        USE grid_variables,                                                     &
@@ -234,6 +236,6 @@
 !--                shear stresses and very small momentum fluxes (both are
 !--                generally unrealistic).
-                   IF ( rifs < rif_min )  rifs = rif_min
-                   IF ( rifs > rif_max )  rifs = rif_max
+                   IF ( rifs < zeta_min )  rifs = zeta_min
+                   IF ( rifs > zeta_max )  rifs = zeta_max
 
 !
@@ -291,5 +293,5 @@
        
        USE control_parameters,                                                 &
-           ONLY:  g, kappa, rif_max, rif_min
+           ONLY:  g, kappa, zeta_max, zeta_min
        
        USE grid_variables,                                                     &
@@ -428,6 +430,6 @@
 !--                shear stresses and very small momentum fluxes (both are
 !--                generally unrealistic).
-                   IF ( rifs < rif_min )  rifs = rif_min
-                   IF ( rifs > rif_max )  rifs = rif_max
+                   IF ( rifs < zeta_min )  rifs = zeta_min
+                   IF ( rifs > zeta_max )  rifs = zeta_max
 
 !
@@ -485,5 +487,5 @@
        
        USE control_parameters,                                                 &
-           ONLY:  g, kappa, rif_max, rif_min
+           ONLY:  g, kappa, zeta_max, zeta_min
        
        USE grid_variables,                                                     &
@@ -596,6 +598,6 @@
 !--       consequence would result in very large shear stresses and very
 !--       small momentum fluxes (both are generally unrealistic).
-          IF ( rifs < rif_min )  rifs = rif_min
-          IF ( rifs > rif_max )  rifs = rif_max
+          IF ( rifs < zeta_min )  rifs = zeta_min
+          IF ( rifs > zeta_max )  rifs = zeta_max
 
 !
Index: palm/trunk/SOURCE/write_3d_binary.f90
===================================================================
--- palm/trunk/SOURCE/write_3d_binary.f90	(revision 1686)
+++ palm/trunk/SOURCE/write_3d_binary.f90	(revision 1691)
@@ -14,10 +14,11 @@
 ! PALM. If not, see <http://www.gnu.org/licenses/>.
 !
-! Copyright 1997-2014 Leibniz Universitaet Hannover
+! Copyright 1997-2015 Leibniz Universitaet Hannover
 !--------------------------------------------------------------------------------!
 !
 ! Current revisions:
 ! -----------------
-! 
+! Added output of radiative heating rates for RRTMG. Added output of ol. Removed
+! output of rif.
 ! 
 ! Former revisions:
@@ -79,6 +80,6 @@
 
     USE arrays_3d,                                                             &
-        ONLY:  e, kh, km, p, pt, q, ql, qc, nr, nrs, nrsws, nrswst, qr, qrs,   &
-               qrsws, qrswst, qs, qsws, qswst, sa, saswsb, saswst, rif,        &
+        ONLY:  e, kh, km, ol, p, pt, q, ql, qc, nr, nrs, nrsws, nrswst, qr,    &
+               qrs, qrsws, qrswst, qs, qsws, qswst, sa, saswsb, saswst,        &
                rif_wall, shf, ts, tswst, u, u_m_l, u_m_n, u_m_r, u_m_s, us,    &
                usws, uswst, v, v_m_l, v_m_n, v_m_r, v_m_s, vpt, vsws, vswst,   &
@@ -110,6 +111,8 @@
     USE radiation_model_mod,                                                   &
         ONLY: radiation, rad_net, rad_net_av, rad_lw_in, rad_lw_in_av,         &
-              rad_lw_out, rad_lw_out_av, rad_sw_in, rad_sw_in_av, rad_sw_out,  &
-              rad_sw_out_av
+              rad_lw_out, rad_lw_out_av, rad_lw_cs_hr, rad_lw_cs_hr_av,        &
+              rad_lw_hr, rad_lw_hr_av, rad_sw_in, rad_sw_in_av, rad_sw_out,    &
+              rad_sw_out_av, rad_sw_cs_hr, rad_sw_cs_hr_av, rad_sw_hr,         &
+              rad_sw_hr_av
 
     USE random_function_mod,                                                   &
@@ -190,4 +193,5 @@
        ENDIF
     ENDIF
+    WRITE ( 14 )  'ol                  ';  WRITE ( 14 )  ol
     WRITE ( 14 )  'p                   ';  WRITE ( 14 )  p
     IF ( ALLOCATED( p_av ) )  THEN
@@ -290,4 +294,16 @@
           WRITE ( 14 )  'rad_lw_out_av       ';  WRITE ( 14 )  rad_lw_out_av  
        ENDIF 
+       IF ( ALLOCATED( rad_lw_cs_hr ) )  THEN
+          WRITE ( 14 )  'rad_lw_cs_hr        ';  WRITE ( 14 )  rad_lw_cs_hr
+       ENDIF
+       IF ( ALLOCATED( rad_lw_cs_hr_av ) )  THEN
+          WRITE ( 14 )  'rad_lw_cs_hr_av     ';  WRITE ( 14 )  rad_lw_cs_hr_av
+       ENDIF
+       IF ( ALLOCATED( rad_lw_hr ) )  THEN
+          WRITE ( 14 )  'rad_lw_hr           ';  WRITE ( 14 )  rad_lw_hr
+       ENDIF
+       IF ( ALLOCATED( rad_lw_hr_av ) )  THEN
+          WRITE ( 14 )  'rad_lw_hr_av        ';  WRITE ( 14 )  rad_lw_hr_av
+       ENDIF
        IF ( ALLOCATED( rad_sw_in ) )  THEN
           WRITE ( 14 )  'rad_sw_in           ';  WRITE ( 14 )  rad_sw_in  
@@ -302,4 +318,16 @@
           WRITE ( 14 )  'rad_sw_out_av       ';  WRITE ( 14 )  rad_sw_out_av  
        ENDIF 
+       IF ( ALLOCATED( rad_sw_cs_hr ) )  THEN
+          WRITE ( 14 )  'rad_sw_cs_hr        ';  WRITE ( 14 )  rad_sw_cs_hr
+       ENDIF
+       IF ( ALLOCATED( rad_sw_cs_hr_av ) )  THEN
+          WRITE ( 14 )  'rad_sw_cs_hr_av     ';  WRITE ( 14 )  rad_sw_cs_hr_av
+       ENDIF
+       IF ( ALLOCATED( rad_sw_hr ) )  THEN
+          WRITE ( 14 )  'rad_sw_hr           ';  WRITE ( 14 )  rad_sw_hr
+       ENDIF
+       IF ( ALLOCATED( rad_sw_hr_av ) )  THEN
+          WRITE ( 14 )  'rad_sw_hr_av        ';  WRITE ( 14 )  rad_sw_hr_av
+       ENDIF
     ENDIF
     IF ( ocean )  THEN
@@ -338,5 +366,4 @@
                                            WRITE ( 14 )  seq_random_array
     ENDIF
-    WRITE ( 14 )  'rif                 ';  WRITE ( 14 )  rif
     IF ( topography /= 'flat' )  THEN
        WRITE ( 14 )  'rif_wall            ';  WRITE ( 14 )  rif_wall
Index: palm/trunk/SOURCE/write_var_list.f90
===================================================================
--- palm/trunk/SOURCE/write_var_list.f90	(revision 1686)
+++ palm/trunk/SOURCE/write_var_list.f90	(revision 1691)
@@ -14,10 +14,11 @@
 ! PALM. If not, see <http://www.gnu.org/licenses/>.
 !
-! Copyright 1997-2014 Leibniz Universitaet Hannover
+! Copyright 1997-2015 Leibniz Universitaet Hannover
 !--------------------------------------------------------------------------------!
 !
 ! Current revisions:
 ! -----------------
-! 
+! Added output of most_method, constant_flux_layer, zeta_min, zeta_max. Removed 
+! output of prandtl_layer and rif_min, rif_max.
 ! 
 ! Former revisions:
@@ -161,4 +162,5 @@
         ONLY:  statistic_regions, hom, hom_sum, u_max, u_max_ijk, v_max,       &
                v_max_ijk, w_max, w_max_ijk
+
     
     IMPLICIT NONE
@@ -167,5 +169,5 @@
 
 
-    binary_version = '3.9b'
+    binary_version = '4.0'
 
     WRITE ( 14 )  binary_version
@@ -273,4 +275,6 @@
     WRITE ( 14 )  conserve_volume_flow_mode
     WRITE ( 14 )  'coupling_start_time           '
+    WRITE ( 14 )  'constant_flux_layer           '
+    WRITE ( 14 )  constant_flux_layer
     WRITE ( 14 )  coupling_start_time
     WRITE ( 14 )  'current_timestep_number       '
@@ -374,4 +378,6 @@
     WRITE ( 14 )  'momentum_advec                '
     WRITE ( 14 )  momentum_advec
+    WRITE ( 14 )  'most_method                   '
+    WRITE ( 14 )  most_method
     WRITE ( 14 )  'nc_const                      '
     WRITE ( 14 )  nc_const
@@ -406,6 +412,4 @@
     WRITE ( 14 )  'phi                           '
     WRITE ( 14 )  phi
-    WRITE ( 14 )  'prandtl_layer                 '
-    WRITE ( 14 )  prandtl_layer
     WRITE ( 14 )  'prandtl_number                '
     WRITE ( 14 )  prandtl_number
@@ -462,8 +466,4 @@
     WRITE ( 14 )  'residual_limit                '
     WRITE ( 14 )  residual_limit
-    WRITE ( 14 )  'rif_max                       '
-    WRITE ( 14 )  rif_max
-    WRITE ( 14 )  'rif_min                       '
-    WRITE ( 14 )  rif_min
     WRITE ( 14 )  'roughness_length              '
     WRITE ( 14 )  roughness_length
@@ -624,4 +624,8 @@
     WRITE ( 14 )  'w_max_ijk                     '
     WRITE ( 14 )  w_max_ijk
+    WRITE ( 14 )  'zeta_max                      '
+    WRITE ( 14 )  zeta_max
+    WRITE ( 14 )  'zeta_min                      '
+    WRITE ( 14 )  zeta_min
     WRITE ( 14 )  'z0h_factor                    '
     WRITE ( 14 )  z0h_factor
